import * as React from "react";
import { ExtractRoutesParams, GetNestedRoutes, Params, ParamsArg, PrependBasePath, Simplify } from "./types";
export { decodeSearch, encodeSearch } from "./search";
export type { Location, Search } from "./types";
export declare const createRouter: <Routes extends Record<string, string>, BasePath extends string = string>(routes: Readonly<Routes>, options?: {
    basePath?: BasePath;
    blockerMessage?: string;
}) => {
    getLocation: () => Readonly<{
        url: string;
        path: readonly string[];
        search: Readonly<import("./types").Search>;
        hash?: string;
    }>;
    createURL: <RouteName extends Exclude<keyof Routes, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>(routeName: RouteName, ...args: ParamsArg<ExtractRoutesParams<Omit<PrependBasePath<Routes, BasePath>, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>[RouteName]>) => string;
    goBack: () => void;
    goForward: () => void;
    navigate: <RouteName_1 extends Exclude<keyof Routes, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>(routeName: RouteName_1, ...args: ParamsArg<ExtractRoutesParams<Omit<PrependBasePath<Routes, BasePath>, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>[RouteName_1]>) => void;
    replace: <RouteName_2 extends Exclude<keyof Routes, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>(routeName: RouteName_2, ...args: ParamsArg<ExtractRoutesParams<Omit<PrependBasePath<Routes, BasePath>, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>[RouteName_2]>) => void;
    subscribe: (subscription: import("./types").Subscription) => () => void;
    unsafeNavigate: (url: string) => void;
    unsafeReplace: (url: string) => void;
    useLink: ({ href, replace, target, }: {
        href: string;
        replace?: boolean | undefined;
        target?: React.HTMLAttributeAnchorTarget | undefined;
    }) => {
        active: boolean;
        onClick: (event: React.MouseEvent) => void;
    };
    useLocation: () => Readonly<{
        url: string;
        path: readonly string[];
        search: Readonly<import("./types").Search>;
        hash?: string;
    }>;
    useRoutes: <RouteName_3 extends keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>> | Exclude<keyof Routes, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>(routeNames: readonly RouteName_3[], { orderBy }?: {
        orderBy?: "asc" | "desc";
    }) => (RouteName_3 extends string ? {
        name: RouteName_3;
        params: Simplify<(ExtractRoutesParams<GetNestedRoutes<PrependBasePath<Routes, BasePath>>> & ExtractRoutesParams<Omit<PrependBasePath<Routes, BasePath>, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>)[RouteName_3]>;
    } : never)[];
    useRoute: <RouteName_4 extends keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>> | Exclude<keyof Routes, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>(routeNames: readonly RouteName_4[]) => RouteName_4 extends string ? {
        name: RouteName_4;
        params: Simplify<(ExtractRoutesParams<GetNestedRoutes<PrependBasePath<Routes, BasePath>>> & ExtractRoutesParams<Omit<PrependBasePath<Routes, BasePath>, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>)[RouteName_4]>;
    } | undefined : never;
    useRouteFocus: ({ route, containerRef, }: {
        route?: {
            name: string;
            params: Params;
        } | undefined;
        containerRef: React.RefObject<unknown>;
    }) => void;
    useBlocker: (blocked: boolean, message?: string) => void;
};
